#include <bits/stdc++.h>
using namespace std;
int main() {
	freopen("dfs.in", "r", stdin);
	freopen("dfs.out", "w", stdout);
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int T;
	cin >> T;
	while (T--) {
		int n, root;
		cin >> n >> root;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		vector<vector<int>> e(n);
		for (int i = 1; i < n; i++) {
			int u, v;
			cin >> u >> v;
			--u;
			--v;
			e[u].push_back(v);
			e[v].push_back(u);
		}
	}
	return 0;
}